//+------------------------------------------------------------------+
//|                                             alb - stochastic.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  2
#property indicator_minimum  0
#property indicator_maximum  100
#property indicator_color1   Lime
#property indicator_color2   Orange
#property indicator_style2   STYLE_DOT

//
//
//
//
//

extern int    swingCount = 5;
extern int    slowing    = 3;
extern int    signal     = 3;
extern int    signalMode = MODE_EMA;
extern int    price      = 0;
extern double speed      = 1.0;

//
//
//
//
//

double swingBuffer[];
double stoBuffer[];
double sigBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,stoBuffer);
   SetIndexBuffer(1,sigBuffer);
   SetIndexBuffer(2,swingBuffer);
      speed = MathMax(speed,0.000001);
   
   return(0);
}
int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      
      int k = i;
      int n = 0;
         for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
               double albPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      stoBuffer[i] = iStochastic(NULL,0,albPeriod,signal,slowing,signalMode,price,MODE_MAIN,i);
      sigBuffer[i] = iStochastic(NULL,0,albPeriod,signal,slowing,signalMode,price,MODE_SIGNAL,i);
   }
   return(0);
}